// TestArrayMod class for ArrayMod lab
// This class tests the array modification methods

// (c) J. Dean Brock, Rebecca F. Bruce, 2001, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.csci201.LabAids ;

/**
 * Tests the array modification methods
 */
public class TestArrayMod {
    
    private static final int ArrayMinSize =  7 ;
    private static final int ArrayMaxSize = 10 ;

    private static String printInt(int I, int W) {
        String R = Integer.toString(I) ;
        for (int i=R.length(); i<W; ++i)
            R = " " + R ;
        return R ;
    }
    
    /**
     * Tests the array modification class
     * @param testObj Array Modification class to be tested
     * @param SolutionSet Solution set number.
     * Passed to edu.unca.cs.LabAids.TestValues to
     * generate test vector.
     */
    public static void TestArrayModification(SpecArrayMod testObj,
                                             int SolutionSet) {
        TestArrayModification(testObj, SolutionSet, System.out) ;
    }

    public static void TestArrayModification(SpecArrayMod testObj,
                                             int SolutionSet,
                                             java.io.PrintStream printOut) {
        edu.unca.cs.LabAids.TestValues runTestSet = 
                    new edu.unca.cs.LabAids.TestValues(SolutionSet) ;
        int ArraySize = Math.abs(runTestSet.getIthInteger(0)) %
                            (ArrayMaxSize-ArrayMinSize) + ArrayMinSize ;
        int testVect[] = new int[ArraySize] ;
        for (int i=0; i<ArraySize; ++i)
            testVect[i] = runTestSet.getIthInteger(i+1) ;
        
        printOut.println("Testing " + testObj.getClass().getName()) ;

        int numColumns = 12 ;
        int numRows = (testVect.length + numColumns - 1)/numColumns ;
        
        int nxtElem = 0 ;
        for (int i=0; i<numRows; ++i) {
            printOut.print(" ") ;
            for (int j=nxtElem; j<Math.min(nxtElem+numColumns, ArraySize); ++j)
                printOut.print(printInt(j, 4) + ":" + printInt(testVect[j], 3)) ;
            nxtElem += numColumns ;
            printOut.println() ;
        }
        
        testObj.TestFunc(testVect) ;
        printOut.println("->") ;
        
        nxtElem = 0 ;
        for (int i=0; i<numRows; ++i) {
            printOut.print(" ") ;
            for (int j=nxtElem; j<Math.min(nxtElem+numColumns, ArraySize); ++j)
                printOut.print(printInt(j, 4) + ":" + printInt(testVect[j], 3)) ;
            nxtElem += numColumns ;
            printOut.println() ;
        }
        printOut.println() ;
    }

}
